using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using Android.App;
using Android.Content;

using Android.Runtime;
using Android.Views;
using Android.Widget;
using System.Threading.Tasks;
using System.IO;
using Java.IO;

using Android.Graphics;
using ImageDrawing.Droid;

[assembly: Xamarin.Forms.Dependency(typeof(SaveAndroid))]
namespace ImageDrawing.Droid
{
    public class SaveAndroid: ISave
    {
        public async Task SaveAsync(string fileName, String contentType, MemoryStream s)
        {
            string root = null;
            if (Android.OS.Environment.IsExternalStorageEmulated)
            {
                root = Android.OS.Environment.ExternalStorageDirectory.ToString();
            }
            else
                root = Environment.GetFolderPath(Environment.SpecialFolder.MyDocuments);

            Java.IO.File myDir = new Java.IO.File(root + "/Syncfusion");
            myDir.Mkdir();

            Java.IO.File file = new Java.IO.File(myDir, fileName);

            if (file.Exists()) file.Delete();

            try
            {
                FileOutputStream outs = new FileOutputStream(file);
                outs.Write(s.ToArray());

                outs.Flush();
                outs.Close();

            }
            catch (Exception e)
            {

            }
            if (file.Exists())
            {
                Android.Net.Uri path = Android.Net.Uri.FromFile(file);
                string extension = Android.Webkit.MimeTypeMap.GetFileExtensionFromUrl(Android.Net.Uri.FromFile(file).ToString());
                string mimeType = Android.Webkit.MimeTypeMap.Singleton.GetMimeTypeFromExtension(extension);
                Intent intent = new Intent(Intent.ActionView);
                intent.SetDataAndType(path, mimeType);
                Xamarin.Forms.Forms.Context.StartActivity(Intent.CreateChooser(intent, "Choose App"));
            }
        }
       
       public Stream ConvertPngToJpeg(Stream stream)
        {
            byte[] image = new byte[stream.Length];
            stream.Read(image, 0, image.Length);

            Bitmap newBitamp = BitmapFactory.DecodeByteArray(image, 0, image.Length);
            Bitmap resultBitmap = Bitmap.CreateBitmap(newBitamp.Width, newBitamp.Height, newBitamp.GetConfig());
            Canvas canvas = new Canvas(resultBitmap);
            canvas.DrawColor(Color.White);
            canvas.DrawBitmap(newBitamp, 0, 0, null);

            //Create memory stream
            MemoryStream outStream = new MemoryStream();

            //Save the image as Jpeg
            resultBitmap.Compress(Bitmap.CompressFormat.Jpeg, 100, outStream);

            //Return the Jpeg image as stream
            return outStream;
        }
    }
}