#region Copyright Syncfusion Inc. 2001-2015.
// Copyright Syncfusion Inc. 2001-2015. All rights reserved.
// Use of this code is subject to the terms of our license.
// A copy of the current license can be obtained at any time by e-mailing
// licensing@syncfusion.com. Any infringement will be prosecuted under
// applicable laws. 
#endregion
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using ImageDrawing.iOS;
using Foundation;
using UIKit;
using Xamarin.Forms;
using System.Threading.Tasks;
using System.IO;
using System.Drawing;
using QuickLook;

[assembly: Dependency(typeof(SaveIOS))]
namespace ImageDrawing.iOS
{
    class SaveIOS:ISave
    {
        public async Task SaveAsync(string filename, string contentType, MemoryStream s)
        {
            string path = Environment.GetFolderPath(Environment.SpecialFolder.MyDocuments);
            string filePath = Path.Combine(path, filename);
            try
            {
                FileStream fileStream = File.Open(filePath, FileMode.Create);
                s.Position = 0;
                s.CopyTo(fileStream);
                fileStream.Flush();
                fileStream.Close();
            }
            catch (Exception e)
            {

            }

            UIViewController currentController = UIApplication.SharedApplication.KeyWindow.RootViewController;
            while (currentController.PresentedViewController != null)
                currentController = currentController.PresentedViewController;
            UIView currentView = currentController.View;

            QLPreviewController qlPreview = new QLPreviewController();
            QLPreviewItem item = new QLPreviewItemBundle(filename, filePath);
            qlPreview.DataSource = new PreviewControllerDS(item);

            currentController.PresentViewController(qlPreview, true, null);
        }

        Stream ISave.ConvertPngToJpeg(Stream stream)
        {
            //Convert image stream into byte array
            byte[] image = new byte[stream.Length];
            stream.Read(image, 0, image.Length);

            //Load the image
            UIKit.UIImage images = new UIImage(Foundation.NSData.FromArray(image));

            //Save the image as Jpeg
            byte[] bytes = images.AsJPEG(100).ToArray();

            //Store the byte array into memory stream
            Stream imgStream = new MemoryStream(bytes);

            //Return the Jpeg image as stream
            return imgStream;
        }
    }
}